#include "framebuffer.h"

FrameBuffer::FrameBuffer(int u0, int v0, 
  int _w, int _h) : Fl_Gl_Window(u0, v0, _w, _h, 0) {

  w = _w;
  h = _h;
  pix = new unsigned int[w*h];
  Set(0xFFFF0000);

}

void FrameBuffer::Set(unsigned int color) {

  for (int i = 0; i < w*h; i++)
    pix[i] = color;

}

void FrameBuffer::draw() {

  glDrawPixels(w, h, GL_RGBA, 
    GL_UNSIGNED_BYTE, pix);

}


void FrameBuffer::Set(int u, int v, unsigned int color) {

  pix[(h-1-v)*w+u] = color;

}

void FrameBuffer::SetChecker(int cw, unsigned int colors[2]) {

  for (int v = 0; v < h; v++) {
    int cv = v / cw;
    for (int u = 0; u < w; u++) {
      int cu = u / cw;
      unsigned int color = ((cu+cv)%2) ? colors[1] : colors[0];
      Set(u, v, color);
    }
  }


}
